VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsScrollText"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'*********************************************************************************************
'Author: Mark Godwin akhnatunsolutions@gmail.com
'Written: June 2012
'Platform: Access 2007
'clsScrollText provides the coding to enable a DB designer to provide scrolling text on a form
'*********************************************************************************************
Option Compare Database
Option Explicit

Public ScrollLength As Integer 'Maximum number of characters that can be displayed in the textbox (or label)
Public ScrollSource As String 'The name of the table (or query) to get the data from OR the string you want to scroll
Public isScrollTextSupplied As Boolean ' If ScrollSource is a table (or query)name then FALSE otherwise TRUE
Public LeadingSpaces As Long 'This is the number of spaces you want between data items
Public ScrollField As String 'the name of the field to get the scroll data from if you have supplied a table (or query) name

Public Function ScrollText() As String

Dim rs As DAO.Recordset
Dim sQry As String
Dim HoldScroll As String
Dim HoldLen As Integer
Dim HoldDiff As Long

If isScrollTextSupplied Then
    HoldScroll = Space(LeadingSpaces) & ScrollSource
    ScrollPoint = ScrollPoint + 1
    If ScrollPoint > Len(ScrollSource) + LeadingSpaces Then ScrollPoint = 1
    ScrollText = Mid(HoldScroll, ScrollPoint, ScrollLength)
Else
    sQry = "SELECT [" & ScrollField & "] FROM " & ScrollSource & ";"
    Set rs = CurrentDb().OpenRecordset(sQry, dbOpenSnapshot)
    With rs
        If .RecordCount = 0 Then
            ScrollText = "Error in reading table:" & ScrollSource
        Else
            .MoveLast
            .MoveFirst
            .Move ScrollItem - 1
            
            If .BOF Or .EOF Then
                .MoveFirst
                ScrollItem = 1
            End If
            
            HoldScroll = .Fields(ScrollField)
            ScrollPoint = ScrollPoint + 1
                       
            HoldLen = Len(HoldScroll) - (ScrollPoint - 1)
            If HoldLen < 0 Then HoldLen = 0
            
            Select Case HoldLen
                Case Is >= ScrollLength 'scrolltext all comes from current record
                    ScrollText = Mid(HoldScroll, ScrollPoint, ScrollLength)
                Case Else 'needs padding
                    ScrollText = Right(HoldScroll, HoldLen)
                    HoldDiff = ScrollLength - HoldLen
                    Select Case HoldDiff
                        Case Is > LeadingSpaces 'needs padding and next scroll item
                            ScrollText = ScrollText & Space(LeadingSpaces)
                            .MoveNext
                            If .EOF Then
                                .MoveFirst
                            End If
                            HoldScroll = .Fields(ScrollField)
                            ScrollText = ScrollText & Left(HoldScroll, ScrollLength - Len(ScrollText))
                        Case Else
                            ScrollText = ScrollText & Space(HoldDiff)
                    End Select
                    If Left(ScrollText, LeadingSpaces) = Space(LeadingSpaces) Then
                        ScrollPoint = 0
                        ScrollItem = ScrollItem + 1
                    End If
                End Select
            End If
        End With
    End If
End Function
